#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include "filter.c"
#include <fcntl.h>
#include <string.h>
#include <linux/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <netinet/in.h>
#include <linux/if_ether.h>
#include <net/if_arp.h>
#include <linux/if_packet.h>
#include <linux/types.h>
#include <sys/uio.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/param.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/if_ether.h>
#include <linux/if_packet.h>
#include <sys/types.h>
#include <sys/time.h>

#if BPF_RELEASE - 0 < 199406
typedef	int bpf_int32;
typedef	u_int bpf_u_int32;
#endif


/*
 * Overlay for ip header used by other protocols (tcp, udp).
 */
struct ipovly {
	u_char	ih_x1[9];		/* (unused) */
	u_char	ih_pr;			/* protocol */
	u_short	ih_len;			/* protocol length */
	struct	in_addr ih_src;		/* source internet address */
	struct	in_addr ih_dst;		/* destination internet address */
};

/*
 * Udp protocol header.
 * Per RFC 768, September, 1981.
 */
struct udphdr {
	u_short	uh_sport;		/* source port */
	u_short	uh_dport;		/* destination port */
	u_short	uh_ulen;		/* udp length */
	u_short	uh_sum;			/* udp checksum */
};

struct  udpiphdr {
  struct  ipovly ui_i;            /* overlaid ip structure */
  struct  udphdr ui_u;            /* udp header */
};

/* Link-level header length */
#ifndef ETHER_HDRLEN
#define ETHER_HDRLEN    sizeof(struct ether_header)
#endif


int errno;
static int bpf_bufsize;
#define BPFBUFSIZE 32768
static char bpf_buf[BPFBUFSIZE];



struct packHandle
{
  int fd;
  int snapshot;
  int timeout;
  char *device;
  int promics;
  struct bpf_program fcode;
};

typedef struct packHandle handle_t;
