#!/bin/sh

cp mnd mnstat /usr/sbin
chmod +x /usr/sbin/mnd
chmod +x /usr/sbin/mnstat

if [ -d /usr/local/man/man8 ]
then
	echo ""
else
	mkdir /usr/local/man/man8
fi
if [ -d /usr/local/man/man5 ]
then
	echo ""
else
	mkdir /usr/local/man/man5
fi
	
cp *.8 /usr/local/man/man8
cp *.5 /usr/local/man/man5

# backup any mnd.conf file if it exists
if [ -f /etc/mnd.conf ]
then
	echo "/etc/mnd.conf EXISTS!, not installing template"
else
	cp /etc/mnd.conf /etc/mnd.conf.bak   # just in case
	cp ../etc/mnd.arp.conf /etc/mnd.conf
	echo "you must edit /etc/mnd.conf"
fi
if [ -f /usr/local/sbin/runmnd.sh ]
then
	echo "/usr/local/sbin/runmnd.sh EXISTS!, not installing template"
else
	cp /usr/local/sbin/runmnd.sh /usr/local/sbin/runmnd.sh.bak
	cp ../etc/runmnd.sh /usr/local/sbin/runmnd.sh
	echo "you must edit /usr/local/sbin/runmnd.sh"
	echo "you may manually start mnd by hand"
	echo "OR you may invoke it from /etc/pcmcia/network at card insertion"
fi
